/*
 * bitbang_uart_Fab.h
 *
 * Created: 11/22/2015 9:21:47 PM
 *  Author: Ben
 */ 


#ifndef BITBANG_UART_FAB_H_
#define BITBANG_UART_FAB_H_

#include <avr/io.h>
#include <util/delay.h>

// Necessary Macros
#define output(directions,pin) (directions |= pin) // set port direction for output
#define set(port,pin) (port |= pin) // set port pin
#define clear(port,pin) (port &= (~pin)) // clear port pin
#define toggle(port, pin) (port ^= pin) // Toggle port pin
#define pin_test(pins,pin) (pins & pin) // test for port pin
#define bit_test(byte,bit) (byte & (1 << bit)) // test for bit set
#define bit_delay_time 102 // bit delay for 9600 baud with overhead. 8.5 for 115200 baud
#define bit_delay() _delay_us(bit_delay_time) // RS232 bit delay
#define half_bit_delay() _delay_us(bit_delay_time/2) // RS232 half bit delay
#define char_delay() _delay_ms(10) // char delay

void put_char(volatile unsigned char *port, unsigned char pin, char txchar);
void get_char(volatile unsigned char *pins, unsigned char pin, char *rxbyte);
void put_string(volatile unsigned char *port, unsigned char pin, char *str);

#endif /* BITBANG_UART_FAB_H_ */